unit USerialXEBasicDemoMain;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFnDEF FPC}
  Vcl.Forms, Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Dialogs, Vcl.StdCtrls,
{$ELSE}
  Forms, SysUtils, Variants, Classes, Graphics, Controls, Dialogs,
{$ENDIF}
  USerialNGXE, UCommPortList, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnPortSettings: TButton;
    Label1: TLabel;
    edtStringToSend: TEdit;
    btnSend: TButton;
    Label2: TLabel;
    memoReceived: TMemo;
    Memo1: TMemo;
    btnListPorts: TButton;
    procedure btnPortSettingsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure btnListPortsClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FSerialPortNGXE : TSerialPortNGXE;
    procedure OnRxClusterEvent(Sender : TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$IFnDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

uses USerialNGXEBasicSettingsDlg;

procedure TForm1.btnPortSettingsClick(Sender: TObject);
begin
  DlgSerialNGXEBasicSettings.SetDlgData(FSerialPortNGXE);
  if DlgSerialNGXEBasicSettings.ShowModal = mrOK then
    DlgSerialNGXEBasicSettings.GetDlgData(FSerialPortNGXE);
end;

procedure TForm1.btnSendClick(Sender: TObject);
begin
  FSerialPortNGXE.SendString(edtStringToSend.Text);
// Für Unicode Strings sollte die Nachfolgende Methode verwendet werden
//  FSerialPortNGXE.SendUnicodeString(edtStringToSend.Text);
end;
procedure TForm1.btnListPortsClick(Sender: TObject);
begin
  GetPortList(Memo1.Lines);
end;

procedure TForm1.OnRxClusterEvent(Sender : TObject);
begin
  MemoReceived.Lines.Add(FSerialPortNGXE.ReadNextClusterAsString);
// Für Unicode Strings sollte die Nachfolgende Methode verwendet werden
//  MemoReceived.Lines.Add(FSerialPortNGXE.ReadNextClusterAsUnicodeString);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSerialPortNGXE := TSerialPortNGXE.Create(Self);
  FSerialPortNGXE.OnRxClusterEvent := OnRxClusterEvent;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FSerialPortNGXE.Active := False;
end;

end.
